/* author GEKU 2019 */
/* v1.3 */

#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <libgen.h>
#include <wchar.h>
#include "iniparser.h"

dictionary *pINI;
char path[256];
char telegram[256];

const char *pToken;
const char *pChat_id;

int emoji;

unsigned short pollcycle;
unsigned short vendor_id;
unsigned short product_id;

const char *pUpEmoji[] =
{
    "",
    "\xF0\x9F\x94\xBC",
    "\xE2\xA4\xB4",
    "\xF0\x9F\x93\x88"
};

const char *pDnEmoji[] =
{
    "",
    "\xF0\x9F\x94\xBD",
    "\xE2\xA4\xB5",
    "\xF0\x9F\x93\x89"
};

int xchg2temp10(const char *px);

int init_sensor_loop(char *pPath)
{
    sprintf(path, "%s/klima-server.ini", dirname(pPath));
    pINI = iniparser_load(path);

    if (pINI == NULL)
    {
        fprintf(stderr, "cannot parse file: %s\n", path);
        return -1;
    }

    pToken = iniparser_getstring(pINI, "BOT:token", NULL);
    pChat_id = iniparser_getstring(pINI, "BOT:chat_id", NULL);
    pollcycle = iniparser_getint(pINI, "SERVER:pollcycle", 60);
    vendor_id = iniparser_getint(pINI, "RS500:vendor_id", 0x0483);
    product_id = iniparser_getint(pINI, "RS500:product_id", 0x5750);

    emoji = iniparser_getint(pINI, "SERVER:emoji", 1) & 0x03;

    {
        char mbuf[256];

        sprintf(path, "%s/telegram-send.sh", pPath);
        strcpy(telegram, path);
        sprintf(mbuf, "%s %s %s '%s %s'", telegram, pToken, pChat_id, "KLIMA-SERVER", " gestartet");
        system(mbuf);
    }
    return 0;
}

void finish_sensor_loop(void)
{
    if (pINI)
    {
        iniparser_freedict(pINI);
    }
}

int sensor_loop(unsigned char buf[256])
{
    char ch = 0;

    do
    {
        const char *pName;

        {
            char entry[16];

            sprintf(entry, "%d:name", ch);
            pName = iniparser_getstring(pINI, entry, NULL);
        }

        if (pName)
        {
            int new_temperature;
            int new_humidity;
            int old_temperature;
            int old_humidity;

            new_temperature = (256 * buf[1 + 3 * ch] + buf[2 + 3 * ch]);
            new_humidity = buf[3 + 3 * ch];

            {
                char entry[16];

                sprintf(entry, "%d:temp10", ch);
                old_temperature = iniparser_getint(pINI, entry, -2731);
            }

            if (abs(new_temperature - old_temperature) > 2)
            {
                if (abs(new_temperature - old_temperature) < 1000)
                {
                    if ((new_temperature - old_temperature) > 0)
                    {
                        const char *px;
                        char entry[16];
                        int ix = 0;

                        sprintf(entry, "%d:TU%d", ch, ix);

                        while (px = iniparser_getstring(pINI, entry, NULL))
                        {
                            int value;

                            value = xchg2temp10(px);

                            if ((value > old_temperature) && (value <= new_temperature))
                            {
                                {
                                    char mbuf[256];
                                    char argument1[32];
                                    char argument2[64];

                                    sprintf(argument1, "*%s*", pName);
                                    sprintf(argument2, "%0.1f°C  %s", (double) new_temperature / 10, pUpEmoji[emoji]);
                                    sprintf(mbuf, "%s %s %s '%s %s'", telegram, pToken, pChat_id, argument1, argument2);
                                    system(mbuf);
                                }
                            }

                            ix++;
                            sprintf(entry, "%d:TU%d", ch, ix);
                        }
                    }
                    else
                    {
                        const char *px;
                        char entry[16];
                        int ix = 0;

                        sprintf(entry, "%d:TD%d", ch, ix);

                        while (px = iniparser_getstring(pINI, entry, NULL))
                        {
                            int value;

                            value = xchg2temp10(px);

                            if ((value < old_temperature) && (value >= new_temperature))
                            {
                                {
                                    char mbuf[256];
                                    char argument1[32];
                                    char argument2[64];

                                    sprintf(argument1, "*%s*", pName);
                                    sprintf(argument2, "%0.1f°C  %s", (double) new_temperature / 10, pDnEmoji[emoji]);
                                    sprintf(mbuf, "%s %s %s '%s %s'", telegram, pToken, pChat_id, argument1, argument2);
                                    system(mbuf);
                                }
                            }

                            ix++;
                            sprintf(entry, "%d:TD%d", ch, ix);
                        }
                    }
                }

                {
                    char entry[16];
                    char new_temp_str[16];

                    sprintf(new_temp_str, "%d", new_temperature);
                    sprintf(entry, "%d:temp10", ch);
                    iniparser_set(pINI, entry, new_temp_str);
                }
            }

            ch++;
        }
        else
        {
            ch = 0;
        }
    }
    while (ch != 0);

    return 0;
}
